import java.net.*;
import java.io.*;

//  This Java code demonstrates how to use the POST method to submit
//  transactions to our (test) transaction processors and process the
//  results.  This secure demo requires the JSSE API. It is an external
//  package for JDK 1.2/1.3 but is integrated into JDK 1.4+.
//
//  Replace existing merchant ID and password below
//  with those assigned to you by ACH Direct.

public class SecurePostTest 
     {
      static String urlStr="https://www.paymentsgateway.net/cgi-bin/posttest.pl";

      // For demonstration purposes, this is a hard-coded test message that we will send to the processor
      static String[] msgLines =
           {
	    "pg_merchant_id=100000",
	    "pg_password=password",
	    "pg_transaction_type=20",
            "pg_total_amount=1.00",
	    "Ecom_BillTo_Postal_Name_First=John",
	    "Ecom_BillTo_Postal_Name_Last=Smith",
	    "Ecom_Payment_Check_AccounT_Type=S",
            "Ecom_Payment_Check_Account=1234567812345678",
	    "Ecom_Payment_Check_TRN=021000021",
	    "endofdata"
	   };

      public static void main(String[] args) throws Exception
           {
            // For POSTing, all content data should be URLEncoded using UTF-8 
	    // before being assembled into a message and sent to the processor
            
            try
              {
               String content="";
       
               for (int i=0;i<msgLines.length;i++)
                 {
                  content+=URLEncoder.encode(msgLines[i],"UTF-8")+"&";
                 }            
      
               System.out.println("\n" + "Transaction:" + "\n" + content);
            
               // this static call will prevent the connection from resolving the redirect
	       // sun.net.www.protocol.http.HttpURLConnection.setFollowRedirects(false);
	       // open the connection, prepare to POST
            
               URL url = new URL(urlStr);
               URLConnection Connection = url.openConnection();

               Connection.setAllowUserInteraction(false);
               Connection.setDoInput(true);
               Connection.setDoOutput(true);
               Connection.setIfModifiedSince(0);
               Connection.setUseCaches(false);

               // write the content and be sure to close
  
               DataOutputStream dos = new DataOutputStream(Connection.getOutputStream());
               dos.writeBytes(content);
	       dos.close();

               // read, parse, and echo the response to the console
   
               BufferedReader br= new BufferedReader(new InputStreamReader(Connection.getInputStream()));
               String line = br.readLine();
 
               System.out.println("\n" + "Response:"); 

               while(line!=null) 
                   {
                    if(line.equals("endofdata"))
                     {
                      System.err.println("END OF DATA = "+line);
                      break;
                     }
	            int equalPos=line.indexOf('=');
                    String name=line.substring(0,equalPos);
                    String value=line.substring(equalPos+1);
                    System.err.println(name+" = "+value);
                    line = br.readLine();
                   }

  	       br.close();
              }

            catch(Exception e)
                {
                 e.printStackTrace();
                }

           }
     }